﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr162_1
{
    // Базовый класс: 
    abstract class Base {
        // Абстрактное свойство: 
        public abstract char symbol { 
            get;
        }
        // Абстрактный индексатор: 
        public abstract int this[int k] { 
            get;
        }
        // Абстрактный метод: 
        public abstract void show(); 
    }

    // Первый интерфейс: 
    interface First {
        // Свойство: 
        char symbol { 
            get;
        }
        // Индексатор: 
        int this[int k] { 
            get;
        }
        // Метод: 
        void show();
    }

    // Второй интерфейс: 
    interface Second {
        // Свойство: 
        char symbol {
            get;
        }
        // Индексатор: 
        int this[int k] { 
            get;
        }
        // Метод: 
        void show();
    }

    // Производный класс наследует абстрактный базовый класс 
    // и реализует интерфейсы: 
    class MyClass: Base, First, Second {
        // Закрытое символьное поле: 
        private char smb;
        // Конструктор с символьньм аргументом: 
        public MyClass(char s): base() { 
            smb = s;
        }
        // Описание свойства из абстрактного класса: 
        public override char symbol { 
            get {
                return smb;
            }
        }
        // Явная реализация свойства из интерфейса First: 
        char First.symbol { 
            get {
                return (char)(smb + 1);
            }
        }
        // Описание индексатора из базового класса: 
        public override int this[int k] {
            get {
                return smb + k;
            }
        }
        // Явная реализация индексатора из интерфейса Second: 
        int Second.this[int k] { 
            get {
                return smb - k;
            }
        }
        // Описание метода из базового класса: 
        public override void show() {
            Console.WriteLine("Базовый класс Base:\t\'{0}\'", symbol);
        }
        // Явная реализация метода из интерфейса First: 
        void First.show() {
            Console.WriteLine("Интерфейс First:\t\'{0}\'", symbol);
        }
        // Явная реализация метода из интерфейса Second: 
        void Second.show() {
            Console.WriteLine("Интерфейс Second:\t\'{0}\'", symbol);
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание объекта:
            MyClass obj = new MyClass('A');
            // Интерфейсные переменные:
            First A = obj;
            Second B = obj;
            // Вызов метода через переменные: 
            obj.show();
            A.show();
            B.show();
            // Считывание значения свойства: 
            Console.WriteLine("obj.symbol = \'{0}\'", obj.symbol);
            Console.WriteLine("  A.symbol = \'{0}\'", A.symbol);
            Console.WriteLine("  B.symbol = \'{0}\'", B.symbol);
            // Индексирование объекта:
            Console.WriteLine("obj[10] = {0}", obj[10]);
            Console.WriteLine("  A[10] = {0}", A[10]);
            Console.WriteLine("  B[10] = {0}", B[10]);
            // Задержка:
            Console.ReadLine();
        }
    }
}
